<template>
  <div
    class="card text-decoration-none"
    :class="{ shadow: isMouseOver }"
    @mouseover="onMouseOver"
    @mouseout="onMouseOut"
  >
    <div class="card-body">
      <router-link
        class="position-absolute w-100 h-100"
        :to="desitinationRoute"
      />
      <h5 class="card-title mb-3">{{ board.name }}</h5>
      <h6 class="card-subtitle mb-5 text-muted">
        <span v-if="numberOfDueCards === 1"
          >{{ numberOfDueCards }} card is due today.</span
        >
        <span v-else>{{ numberOfDueCards }} cards are due today.</span>
      </h6>
      <div class="progress">
        <div
          class="progress-bar w-75"
          role="progressbar"
          aria-valuenow="75"
          aria-valuemin="0"
          aria-valuemax="100"
        ></div>
      </div>
      <span
        @click="openOptions = true"
        type="button"
        class="edit-board bg-primary text-white position-absolute d-flex justify-content-center align-items-center rounded-circle"
      >
        <app-icon icon="pen" size="xs"></app-icon>
      </span>
      <board-options
        :id="board.id"
        :open="openOptions"
        @cancel="closeOptions"
        @rename="handleRenameBoard"
        @delete="handleDeleteBoard"
        @move-left="handleMoveBoardLeft"
        @move-right="handleMoveBoardRight"
      />
      <board-edit-form
        :board="board"
        :open="openEditForm"
        @rename="handleUpdateBoard"
        @cancel="openEditForm = false"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { Board, Card, List, LocalDatabase } from "@/core/database";
import { defineComponent, PropType } from "vue";
import BoardEditForm from "./BoardEditForm.vue";
import BoardOptions from "./BoardOptions.vue";
import dayjs from "dayjs";
import isSameOrBefore from "dayjs/plugin/isSameOrBefore";
import { CardRepository } from "@/core/repositories";
import { ListRepository } from "@/core/repositories/list-repository";
import { RouteLocationRaw } from "vue-router";
import { Observable, Subscription } from "rxjs";
import { SubSink } from "subsink";
dayjs.extend(isSameOrBefore);

export default defineComponent({
  components: { BoardEditForm, BoardOptions },
  emits: ["delete", "list", "update", "sort"],
  props: {
    board: {
      type: Object as PropType<Board>,
      required: true,
    },
    index: {
      type: Number,
      required: true,
    },
  },
  created() {
    LocalDatabase.getInstance().then(async (db) => {
      this.listRepository = ListRepository.getInstance(db);
      this.cardRepository = CardRepository.getInstance(db);
      const listObservable = await this.listRepository.watchAllItems();
      this.subSink.sink = listObservable.subscribe(async (lists) => {
        if (lists) {
          const cards: Card[] = [];

          for (let index = 0; index < lists.length; index++) {
            const list = lists[index];
            const cardObservable = await this.cardRepository.watchAllItems(
              "id",
              list.id
            );

            this.subSink.sink = cardObservable.subscribe(async (cards) => {
              if (cards) {
                this.cards = cards;
              }
            });
          }
        }
      });
    });
  },
  data() {
    return {
      isMouseOver: false,
      openEditForm: false,
      openOptions: false,
      cards: [] as Card[],
      listRepository: {} as ListRepository,
      cardRepository: {} as CardRepository,
      subSink: new SubSink(),
    };
  },
  computed: {
    numberOfDueCards(): number {
      return this.cards.filter((card) =>
        dayjs(card.date).isSameOrBefore(dayjs())
      ).length;
    },
    numberOfCards(): number {
      return this.cards.length;
    },
    desitinationRoute(): RouteLocationRaw {
      return {
        name: "kanban",
        params: {
          boardId: this.board.id,
        },
      };
    },
  },
  methods: {
    onMouseOver() {
      this.isMouseOver = true;
    },
    onMouseOut() {
      this.isMouseOver = false;
    },
    closeOptions() {
      this.openOptions = false;
    },
    handleRenameBoard() {
      this.openEditForm = true;
      this.closeOptions();
    },
    handleDeleteBoard() {
      this.closeOptions();
      this.$emit("delete", this.board);
    },
    handleUpdateBoard(updatedBoard: Board) {
      this.closeOptions();
      this.$emit("update", updatedBoard);
    },
    handleMoveBoardLeft() {
      this.closeOptions();
      this.$emit("sort", {
        index: this.index,
        direction: "left",
        board: this.board,
      });
    },
    handleMoveBoardRight() {
      this.closeOptions();
      this.$emit("sort", {
        index: this.index,
        direction: "right",
        board: this.board,
      });
    },
  },
  unmounted() {
    this.subSink.unsubscribe();
  },
});
</script>

<style scoped>
.card {
  transition: box-shadow 100ms ease-out;
}

.edit-board {
  width: 25px;
  height: 25px;
  font-size: 0.75rem;
  right: 0;
  top: 0;
  margin: 1.25rem;
  transition: transform 200ms ease;
  z-index: 30;
}

.edit-board:hover {
  transform: rotateZ(360deg);
}
</style>
